ext @Temp@Byte
ext @Temp@Word
ext @Temp@Word2

@Temp@WordH equ @Temp@Word
@Temp@WordL equ @Temp@Word+1
@Temp@Word2H equ @Temp@Word2
@Temp@Word2L equ @Temp@Word2+1


    cseg

tempo equ 180*2

dseg
SoundProc_: public SoundProc_
    defw 0
cycle defw 0
cycle_Hi equ cycle
cycle_Lo equ cycle+1

cseg

InitSound_: public InitSound_
    clr SoundProc_
    clr SoundProc_+1
rts


CallSound_: public CallSound_
    ldx SoundProc_
    if ne
        jsr 0,x
        clr SoundProc_
        clr SoundProc_+1
    endif
rts


Tone:
; in:
;   b: length
    psha
        clr $c80d
        ldaa #$e0
        staa $c80b
        
        stab $c808
        clr $c809

        ldaa cycle_Lo
        staa $c804
        ldaa cycle_Hi
        staa $c805

        do 
            ldaa $c80d
            bita #$20
        while eq | wend
        ldaa #$20
        staa $c80b
    pula
rts


Sound_Hit:
    psha
    pshb
        ldx #2000
        stx cycle
        ldab #20
        do
            pshb
                ldab #2
                bsr Tone
                ldaa cycle_Lo
                suba #50
                staa cycle_lo
                ldaa cycle_hi
                sbca #0
                staa cycle_hi    
            pulb
            decb
        while ne | wend
    pulb
    pula
rts

Sound_Hit_: public Sound_Hit_
    ldx #Sound_Hit
    stx SoundProc_
rts


Sound_Loose:
    psha
    pshb
        ldx #1000
        stx cycle
        ldab #20
        do
            pshb
                ldab #2
                bsr Tone
                ldaa cycle_Lo
                adda #50
                staa cycle_lo
                ldaa cycle_hi
                adca #0
                staa cycle_hi    
            pulb
            decb
        while ne | wend
    pulb
    pula
rts

Sound_Loose_: public Sound_Loose_
    ldx #Sound_Loose
    stx SoundProc_
rts


Melody:
    ldaa #$e0
    staa $c80b
    stx <@Temp@Word
    do
        ldx <@Temp@Word
        ldab 0,x
    while ne
        inx
        ldaa 0,x
        if eq
            inx
            stx <@Temp@Word
            ldaa #$20
            staa $c80b
            do
                ldx #(1118608/tempo)
                do
                    dex
                while ne | wend
                decb
            while ne | wend
            ldaa #$e0
            staa $c80b
        else
            deca
            staa <@Temp@byte
            asla
            adda <@Temp@byte
            inx
            stx <@Temp@Word
            
            ldx #cycles
            stx <@Temp@Word2
            adda <@Temp@Word2L
            staa <@Temp@Word2L
            ldaa <@Temp@Word2H
            adca #0
            staa <@Temp@Word2H
            ldx <@Temp@Word2

            ldaa 1,x
            staa $c804
            ldaa 0,x
            staa $c805

            do
                clr $c80d
                ldaa 2,x
                staa $c808
                clr $c809
                do 
                    ldaa $c80d
                    bita #$20
                while eq | wend
                decb
            while ne | wend
        endif
    wend
    ldaa #$20
    staa $c80b
rts

C4 equ 1
C4S equ 2
D4 equ 3
E4 equ 5
F4 equ 6
G4 equ 8
A4 equ 10
B4 equ 12
C5 equ 13
D5 equ 15
E5 equ 17

N8 equ 6
N8P equ N8*3/2
N4 equ N8*2
N4P equ N4*3/2
N2 equ N4*2
N2P equ N2*3/2
N1 equ N2*2


beep_notes:
    defb 1,A4 ,1,0, 0
Sound_Beep_: public Sound_Beep_
    psha 
    pshb
        ldx #beep_notes
        bsr Melody
    pulb
    pula
rts


get_notes:
    defb 1,C4, 1, C4S, 1,D4, 1,F4, 1,A4, 1,C5, 0
Sound_Get:
    ldx #get_notes
bra Melody
Sound_Get_:  public Sound_Get_
    ldx #Sound_Get
    stx SoundProc_
rts


start_notes: 
	defb 11,C4,1,0, 11,E4,1,0
	defb 5,G4,1,0, 11,E4,1,0, 11,F4,1,0
	defb 5,F4,1,0, 11,A4,1,0, 5,C5,1,0
	defb 17,A4,1,0, 31,C5,5,0
	defb 12,0
    defb 0
Sound_Start_: 
    public Sound_Start_
    psha 
    pshb
        ldx #start_notes
        bsr Melody
    pulb
    pula
rts


clear_notes: 
	defb 5,A4,1,0, 5,A4,1,0, 5,G4,1,0, 5,F4,1,0
	defb 5,G4,1,0, 11,A4,1,0, 11,B4,1,0
	defb 5,B4,1,0, 5,A4,1,0, 5,G4,1,0, 5,A4,1,0
	defb 11,B4,1,0, 29,C5,1,0
	defb 24,0
    defb 0
Sound_Clear_:
    public Sound_Clear_
    psha 
    pshb
        ldx #clear_notes
        bsr Melody
    pulb
    pula
rts


over_notes: 
	defb 5,C5,1,0, 5,F4,1,0, 5,A4,1,0, 5,E4,1,0
	defb 5,G4,1,0, 5,A4,1,0, 5,B4,1,0, 5,C5,1,0
	defb 31,C5,5,0
	defb 12,0
    defb 0
Sound_GameOver_: public Sound_GameOver_
    psha 
    pshb
        ldx #over_notes
        bsr Melody
    pulb
    pula
rts


cycles: public cycles
defw 1713 | defb 2616/tempo ;C4
defw 1617 | defb 2771/tempo ;C#4
defw 1527 | defb 2936/tempo ;D4
defw 1441 | defb 3111/tempo ;D#4
defw 1360 | defb 3296/tempo ;E4
defw 1284 | defb 3492/tempo ;F
defw 1212 | defb 3699/tempo ;F#4
defw 1144 | defb 3919/tempo ;G4
defw 1080 | defb 4153/tempo ;G#4
defw 1020 | defb 4400/tempo ;A4
defw 963 | defb 4661/tempo ;A#4
defw 909 | defb 4938/tempo ;B4
defw 858 | defb 5232/tempo ;C5
defw 810 | defb 5543/tempo ;C#5
defw 765 | defb 5873/tempo ;D5
defw 722 | defb 6222/tempo ;D#5
defw 682 | defb 6592/tempo ;E5
